#ifdef WIN32
#include <winsock2.h>
#else
#include <sys/mman.h>
#include <unistd.h>
#include <link.h>
#include <sys/socket.h>
#endif

#include <ctime>
#include <stdio.h>
#include "stub_mm.h"
#include "Deture.h"

StubPlugin g_StubPlugin;

#ifdef WIN32
#define CTYPE __stdcall
#define FTIMEOUT WSAETIMEDOUT
#else
#define CTYPE
#define SOCKET int
#define FTIMEOUT ETIMEDOUT
#endif

CDeture sendto_deture;
CDeture recvfrom_deture;

char g_last_buff[4096];
int g_len = 0;
time_t g_last_upd = 0;


#define A2S_INFO_RRQUEST		"\xFF\xFF\xFF\xFF\x54" 
#define A2S_INFO_REPLY			"\xFF\xFF\xFF\xFF\x49" 


ConVar qc_time("qc_time", "5", 0, "Query Cache timeout in sec", true, 0, true, 3600);

typedef int (CTYPE *sendto_t)(SOCKET, const char* , int, int , const sockaddr*, int);
typedef int (CTYPE *recvfrom_t)(SOCKET, char* ,int, int, struct sockaddr*,int*);

int CTYPE recvfrom_fake(SOCKET s, char* buf, int len,int flags,struct sockaddr* from,int* fromlen){
	recvfrom_t original_ptr = (recvfrom_t)recvfrom_deture.original_ptr();
	int iRc = 0;
	iRc = original_ptr(s, buf, len, flags, from, fromlen);
	if(iRc > 5){
		if(memcmp(buf, A2S_INFO_RRQUEST, 5) == 0){
			if(difftime(time(NULL), g_last_upd) < double(qc_time.GetInt())){
				sendto_t sendto_original_ptr = (sendto_t)sendto_deture.original_ptr();
				sendto_original_ptr(s, g_last_buff, g_len, 0, from, *fromlen );
				flags = FTIMEOUT;
				return -1;
			}
		}
	}
	return iRc;
}

int CTYPE sendto_fake(SOCKET s, const char* buf, int len, int flags, const sockaddr* to, int tolen){
	sendto_t original_ptr = (sendto_t)sendto_deture.original_ptr();
	if(len > 5){
		if(memcmp(A2S_INFO_REPLY, buf, 5) == 0){
			if(difftime(time(NULL), g_last_upd) >= double(qc_time.GetInt())){
				g_last_upd = time(NULL);
				memcpy(g_last_buff, buf, len);
				g_len = len;
			}
		}
	}
	return original_ptr(s, buf, len, flags, to, tolen);
}
IServerGameDLL *server = NULL;
ICvar *icvar = NULL;

class BaseAccessor : public IConCommandBaseAccessor
{
public:
	bool RegisterConCommandBase(ConCommandBase *pCommandBase)
	{
		return META_REGCVAR(pCommandBase);
	}
} s_BaseAccessor;

PLUGIN_EXPOSE(StubPlugin, g_StubPlugin);
bool StubPlugin::Load(PluginId id, ISmmAPI *ismm, char *error, size_t maxlen, bool late)
{
	PLUGIN_SAVEVARS();
	/* Make sure we build on MM:S 1.4 */
#if defined METAMOD_PLAPI_VERSION
	GET_V_IFACE_ANY(GetServerFactory, server, IServerGameDLL, INTERFACEVERSION_SERVERGAMEDLL);
#else
	GET_V_IFACE_ANY(serverFactory, server, IServerGameDLL, INTERFACEVERSION_SERVERGAMEDLL);
#endif
	
#if SOURCE_ENGINE >= SE_ORANGEBOX
	GET_V_IFACE_CURRENT(GetEngineFactory, icvar, ICvar, CVAR_INTERFACE_VERSION);
	g_pCVar = icvar;
	ConVar_Register(0, &s_BaseAccessor);
#else
	ConCommandBaseMgr::OneTimeInit(&s_BaseAccessor);
#endif
	recvfrom_deture.hook_function((void*)recvfrom, (void*)recvfrom_fake);
	sendto_deture.hook_function((void*)sendto, (void*)sendto_fake);
	return true;
}

bool StubPlugin::Unload(char *error, size_t maxlen)
{
	recvfrom_deture.unhook();
	sendto_deture.unhook();
	g_last_upd = 0;
	return true;
}


void StubPlugin::AllPluginsLoaded()
{

}

bool StubPlugin::Pause(char *error, size_t maxlen)
{
	return true;
}

bool StubPlugin::Unpause(char *error, size_t maxlen)
{
	return true;
}

const char *StubPlugin::GetLicense()
{
	return "Public Domain";
}

const char *StubPlugin::GetVersion()
{
	return "1.0.0.3";
}

const char *StubPlugin::GetDate()
{
	return __DATE__;
}

const char *StubPlugin::GetLogTag()
{
	return "QC";
}

const char *StubPlugin::GetAuthor()
{
	return "ivailosp";
}

const char *StubPlugin::GetDescription()
{
	return "Query Cache plugin";
}

const char *StubPlugin::GetName()
{
	return "QCache Plugin";
}

const char *StubPlugin::GetURL()
{
	return "n/A";
}
